﻿/*
 *Copyright(C) 2020 by  Cyf All rights reserved.
 *Unity版本：2021.3.11f1c2 
 *作者:程一峰  
 *创建日期: 2022-11-10 
 *模块说明：木蝴蝶数学库：数据格式
 *版本: 1.0
*/

using System;
using Unity.Mathematics;

namespace Oroxylum
{
    /// <summary>
    ///  AxisAlignedBox3d
    ///  AABB 规整的立方体
    /// </summary>
    public struct Box3dAABB
    {

        public float3 Min;
        public float3 Max;

        public Box3dAABB(float3 vMin, float3 vMax)
        {
            Min = new float3(math.min(vMin.x, vMax.x), math.min(vMin.y, vMax.y), math.min(vMin.z, vMax.z));
            Max = new float3(math.max(vMin.x, vMax.x), math.max(vMin.y, vMax.y), math.max(vMin.z, vMax.z));
        }

        public float Width => math.max(Max.x - Min.x, 0);
        public float Height => math.max(Max.y - Min.y, 0);
        public float Depth => math.max(Max.z - Min.z, 0);
        /// <summary>
        /// 体积
        /// </summary>
        public float Volume => Width * Height * Depth;

        public float3 Diagonal=> new float3(Max.x - Min.x, Max.y - Min.y, Max.z - Min.z); 
        public float3 Extents=>new float3((Max.x - Min.x) * 0.5f, (Max.y - Min.y) * 0.5f, (Max.z - Min.z) * 0.5f); 
        public float3 Center=>new float3(0.5f * (Min.x + Max.x), 0.5f * (Min.y + Max.y), 0.5f * (Min.z + Max.z)); 

    }
}