﻿/*
 *Copyright(C) 2023 by GYYX All rights reserved.
 *Unity版本：2020.3.48f1 
 *作者:程一峰  
 *创建日期: 2023-06.16 
 *模块说明：多线程通用库
 *版本: 1.0
*/

namespace Oroxylum
{
    /// <summary>
    /// 多线程对象池接口
    /// </summary>
    public interface IConcurrentPoolItem
    {

        /// <summary>
        /// 创建时调用
        /// </summary>
        public void OnCreate();

        /// <summary>
        /// 获取时调用
        /// </summary>
        public void OnGet();

        /// <summary>
        /// 回收时调用
        /// </summary>
        public void OnPut();

        /// <summary>
        /// 标记是否可回收
        /// </summary>
        public bool Recyclable { get; }

    }
}
